import org.eclipse.jface.resource.*;
import org.eclipse.jface.util.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.jface.window.ApplicationWindow;

public class ShowRegistryExample extends ApplicationWindow implements
    IPropertyChangeListener {
  private static final String FOREGROUND = "foreground";
  private static final String FONT = "font";
  Label label;
  ColorRegistry colorRegistry;
  FontRegistry fontRegistry;

  public ShowRegistryExample() {
    super(null);
  }
  protected Control createContents(Composite parent) {
    Composite composite = new Composite(parent, SWT.NONE);
    composite.setLayout(new FillLayout(SWT.VERTICAL));

    colorRegistry = new ColorRegistry();
    colorRegistry.addListener(this);

    fontRegistry = new FontRegistry();
    fontRegistry.addListener(this);

    label = new Label(composite, SWT.CENTER);
    label.setText("Hello World");

    Button button = new Button(composite, SWT.PUSH);
    button.setText("Show");
    button.addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e) {
        colorRegistry.put(FOREGROUND, new RGB((int) (Math.random() * 255), (int) (Math
            .random() * 255), (int) (Math.random() * 255)));
        FontData data = new FontData("Arial Narrow",
           (int) (Math.random() * 62), SWT.BOLD);
        fontRegistry.put(FONT, new FontData[] { data});
      }
    });
    return composite;
  }
  public void propertyChange(PropertyChangeEvent event) {
    if (colorRegistry.hasValueFor(FOREGROUND)){
		label.setForeground(colorRegistry.get(FOREGROUND));
	}
    if (fontRegistry.hasValueFor(FONT)){
		label.setFont(fontRegistry.get(FONT));
	}
    getShell().pack();
  }
  public static void main(String[] args) {
   ShowRegistryExample example= new ShowRegistryExample();
	example.setBlockOnOpen(true);
    example.open();
    Display.getCurrent().dispose();
  }
}

           